/*
 * $Header: /Users/pizlo/Repository/tsf/complex_any_test_types.t,v 1.2 2007/05/10 05:13:04 pizlo Exp $
 *
 * complex_any_test_types.t -- types used by the complex_any_test
 * by Filip Pizlo, 2003, 2004
 */


/** this array contains instances of the other stuff in this file. */
declare cat_carrier: array of any


/** a chat message */
declare cat_chat_msg: struct {
    /** the name of the target of this message */
    target:     string
    
    /** the name of the source of this message */
    source:     string
    
    /** the message itself */
    message:    array of uint8
}


/** a file fragment */
declare cat_file_frag: struct {
    /** a hash code computed over the fragment */
    hash:       uint64
    
    /** the fragment itself, represented as an array of bytes */
    data:       array of uint8
}


/** topology message */
declare cat_topo_msg: struct {
    /** the source of this message */
    source:     string
    
    /** a list of the names of nodes that are adjacent to the source of
     * this message */
    adjacency:  array of string
}



