/*
 * conformance_test_writer.c -- the writing end of conformance tests
 * by Filip Pizlo, 2004, 2005
 */

#include "tsf_test.h"
#include "tsf.h"
#include "write_cases.h"

#include <stdio.h>
#include <ctype.h>

static tsf_stream_file_output_t *output;

static void doit(tsf_reflect_t *r) {
    tsf_buffer_t *buf;
    
    TAT(buf=tsf_reflect_make_buffer(r));
    
    tsf_reflect_destroy(r);
    
    TAT(tsf_stream_file_output_write(output,buf));
    
    tsf_buffer_destroy(buf);
}

int main(int c,char **v) {
    if (c<3) {
        fprintf(stderr,"Usage: %s <output file name> <use comments>\n",v[0]);
        return 1;
    }
    
    output=tsf_stream_file_output_open(v[1],tsf_false,NULL);
    if (output==NULL) {
        fprintf(stderr,"Could not open file for writing: %s\n",
                       tsf_get_error());
        return 1;
    }
    
    TEST_INIT_NOFORK(c,v);
    
    do_tests(tolower(v[2][0])=='t',doit);
    
    if (!tsf_stream_file_output_close(output)) {
        fprintf(stderr,"Could not close file: %s\n",
                       tsf_get_error());
        return 1;
    }
    
    TEST_DONE_CUSTOM(" Done.");
    
    return 0;
}



