/*
 * $Header: /Users/pizlo/Repository/tsf/tsf_asprintf.c,v 1.1.1.1 2007/05/02 23:31:05 pizlo Exp $
 *
 * tsf_asprintf.c -- implements asprintf, if it is not found.
 * by Filip Pizlo, 2003, 2004, 2005
 */

#include "tsf_internal.h"

#include <stdio.h>
#include <string.h>

char *tsf_vasprintf(const char *format,va_list lst1,va_list lst2) {
    char *ret;
    int res;
#ifdef TSF_HAVE_VASPRINTF
    res=vasprintf(&ret,format,lst1);
    if (res<0 && ret!=NULL) {
        free(ret);
        ret=NULL;
    }
#else
    {
        char fake_buf[32];
        res=vsnprintf(fake_buf,sizeof(fake_buf),format,lst1);
        if (res<0) {
            return NULL;
        }
        if (res<32) {
            return strdup(fake_buf);
        }
        ret=malloc(res+1);
        if (ret==NULL) {
            return NULL;
        }
        res=vsnprintf(ret,res+1,format,lst2);
        if (res<0) {
            free(ret);
            ret=NULL;
        }
    }
#endif
    return ret;
}

char *tsf_asprintf(const char *format,...) {
    va_list lst1,lst2;
    char *ret;
    va_start(lst1,format);
    va_start(lst2,format);
    ret=tsf_vasprintf(format,lst1,lst2);
    va_end(lst1);
    va_end(lst2);
    return ret;
}

