/*
 * $Header: /Users/pizlo/Repository/tsf/tsf_bdb_protocol.h,v 1.1.1.1 2007/05/02 23:31:06 pizlo Exp $
 *
 * tsf_bdb_protocol.h -- holds constants required by the BDB protocol.
 * by Filip Pizlo, 2003, 2004, 2005
 */

#ifndef FP_TSF_BDB_PROTOCOL_H
#define FP_TSF_BDB_PROTOCOL_H

/* What follows are the key codes used by the internal TSF records in BDB
 * dictionary files.
 *
 * These codes take advantage of the fact that the length of a key is
 * significant in BDB, and that the TSF buffer to DBT key transformation
 * will always produce a DBT that is at least four bytes long.  Hence, all
 * special TSF records have a key that is at most three bytes long.  This
 * prevents all collisions. */

/* This is the main (and currently only) special key.  The record at this
 * key contains all of the types that are used in the file. */
#define TSF_BP_TYPES    "Typ"

#endif


