/*
 * $Header: /Users/pizlo/Repository/tsf/tsf_format.h,v 1.1.1.1 2007/05/02 23:31:06 pizlo Exp $
 *
 * tsf_format.h -- defines format macros for use with sprintf and friends.
 *                 these are shorter and more friendly than the standard ones.
 * by Filip Pizlo, 2003, 2004, 2005
 */

#ifndef FP_TSF_FORMAT_H
#define FP_TSF_FORMAT_H

#include "tsf_config.h"

#include <inttypes.h>

#define fi8 "%" PRId8
#define fui8 "%" PRIu8
#define fi16 "%" PRId16
#define fui16 "%" PRIu16
#define fi32 "%" PRId32
#define fui32 "%" PRIu32
#define fi64 "%" PRId64
#define fui64 "%" PRIu64

#if TSF_SIZEOF_SIZE_T == 2
#define fsz fui16
#else
#if TSF_SIZEOF_SIZE_T == 4
#define fsz fui32
#else
#if TSF_SIZEOF_SIZE_T == 8
#define fsz fui64
#else
#error "Don't know how to print size_t"
#endif
#endif
#endif

#if TSF_SIZEOF_VOID_P == 2
#define fptr fi16
#define fuptr fui16
#else
#if TSF_SIZEOF_VOID_P == 4
#define fptr fi32
#define fuptr fui32
#else
#if TSF_SIZEOF_VOID_P == 8
#define fptr fi64
#define fuptr fui64
#else
#error "Don't know how to print void *"
#endif
#endif
#endif

#endif


