/*
 * tsf_limits.c -- implementation of limits
 * by Filip Pizlo, 2004, 2005
 */

#include "tsf_internal.h"

tsf_limits_t *tsf_limits_create() {
    tsf_limits_t *result=malloc(sizeof(tsf_limits_t));
    if (result==NULL) {
        tsf_set_errno("Could not malloc tsf_limits_t");
        return NULL;
    }
    
    result->max_types           = UINT32_MAX;
    result->max_type_size       = UINT32_MAX;
    result->max_total_type_size = UINT32_MAX;
    result->max_buf_size        = UINT32_MAX;
    result->depth_limit         = UINT32_MAX;
    memset(&(result->allow_type_kind),255,32);
    result->max_array_length    = UINT32_MAX;
    result->max_struct_size     = UINT32_MAX;
    result->max_choice_size     = UINT32_MAX;
    result->max_string_size     = UINT32_MAX;
    
    return result;
}

void tsf_limits_destroy(tsf_limits_t *limits) {
    if (limits==NULL) {
        return;
    }
    free(limits);
}

tsf_limits_t *tsf_limits_clone(tsf_limits_t *limits) {
    tsf_limits_t *result=malloc(sizeof(tsf_limits_t));
    if (result==NULL) {
        tsf_set_errno("Could not malloc tsf_limits_t");
        return NULL;
    }
    
    memcpy(result,limits,sizeof(tsf_limits_t));
    
    return result;
}




