/*
 * tsf_part_file.c
 * by Filip Pizlo, 2007
 */

#include "tsf_internal.h"
#include "tsf_format.h"
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>

char *tsf_create_part_file(const char *filename,int mode) {
    uint32_t i;
    for (i=1;;i++) {
	char *result;
	int fd;
	result=tsf_asprintf("%s.tmp" fui32,filename,i);
	if (result==NULL) {
	    tsf_set_errno("Could not do tsf_asprintf");
	    return NULL;
	}
	fd=open(result,O_CREAT|O_EXCL|O_WRONLY,mode);
	if (fd>=0) {
	    close(fd);
	    return result;
	}
	if (errno!=EEXIST) {
	    tsf_set_errno("Could not create %s",result);
	    free(result);
	    return NULL;
	}
	free(result);
    }
}

