/*
 * $Header: /Users/pizlo/Repository/tsf/tsf_primitive.c,v 1.1.1.1 2007/05/02 23:31:06 pizlo Exp $
 *
 * tsf_primitive.c -- the right place for a bunch of primitive-related stuff
 *                    that doesn't fit anywhere else.
 * by Filip Pizlo, 2003, 2004, 2005
 */

#include "tsf_internal.h"

/* FIXME: primitive type should really just all be instances of each other. */
tsf_bool_t tsf_primitive_type_kind_instanceof(tsf_type_kind_t one,
                                              tsf_type_kind_t two) {
    return tsf_primitive_type_kind_lower_bound(one)
	>= tsf_primitive_type_kind_lower_bound(two)
	&& tsf_primitive_type_kind_upper_bound(one)
	<= tsf_primitive_type_kind_upper_bound(two)
	&& tsf_primitive_type_kind_precision(one)
	<= tsf_primitive_type_kind_precision(two);
}

#define test_type_kind(kind_code) \
    if (lower_bound >= tsf_primitive_type_kind_lower_bound(kind_code) && \
	upper_bound <= tsf_primitive_type_kind_upper_bound(kind_code) && \
	precision <= tsf_primitive_type_kind_precision(kind_code)) { \
	return kind_code; \
    }

tsf_type_kind_t tsf_primitive_type_kind_for_spec(int32_t lower_bound,
						 int32_t upper_bound,
						 int32_t precision) {
    test_type_kind(TSF_TK_INT8);
    test_type_kind(TSF_TK_UINT8);
    test_type_kind(TSF_TK_INT16);
    test_type_kind(TSF_TK_UINT16);
    test_type_kind(TSF_TK_INT32);
    test_type_kind(TSF_TK_UINT32);
    test_type_kind(TSF_TK_INT64);
    test_type_kind(TSF_TK_UINT64);
    test_type_kind(TSF_TK_FLOAT);
    return TSF_TK_DOUBLE;
}

tsf_type_kind_t tsf_primitive_type_kind_mix(tsf_type_kind_t one,
					    tsf_type_kind_t two) {
    return tsf_primitive_type_kind_for_spec
	(tsf_min(tsf_primitive_type_kind_lower_bound(one),
		 tsf_primitive_type_kind_lower_bound(two)),
	 tsf_max(tsf_primitive_type_kind_upper_bound(one),
		 tsf_primitive_type_kind_upper_bound(two)),
	 tsf_max(tsf_primitive_type_kind_precision(one),
		 tsf_primitive_type_kind_precision(two)));
}





