/*
 * $Header: /Users/pizlo/Repository/tsf/tsf_sort.c,v 1.1.1.1 2007/05/02 23:31:06 pizlo Exp $
 *
 * tsf_sort.c -- sorting is fun.
 * by Filip Pizlo, 2003, 2004, 2005
 */

#include "tsf_internal.h"

#ifdef HAVE_QSORT

void tsf_sort(void *base,size_t nmemb,size_t size,
              int (*compar)(const void *a,const void *b)) {
    qsort(base,nmemb,size,compar);
}

#else

#error "I haven't written my own sorting algorithm yet.  Bummer."

#endif

static int ui32_compare(const void *pa,
                        const void *pb) {
    uint32_t a = *((uint32_t*)pa),
             b = *((uint32_t*)pb);
    
    if (a<b) {
        return -1;
    } else if (a==b) {
        return 0;
    } else {
        return 1;
    }
}

void tsf_ui32_sort(uint32_t *base,
                   size_t nmemb) {
    tsf_sort(base,nmemb,sizeof(uint32_t),ui32_compare);
}

