/* $Header: /Users/pizlo/Repository/tsf/tsf_st.h,v 1.1.1.1 2007/05/02 23:31:06 pizlo Exp $ */

/* this file has been modified again by Filip Pizlo, 2003, 2004, 2005, to be
 * incorporated into tsf. */
/* this file has been modified by Filip Pizlo, 2002, to support C++ */
/* This is a public domain general purpose hash table package written by Peter Moore @ UCB. */

/* @(#) st.h 5.1 89/12/14 */

#ifndef TSF_ST_INCLUDED

#define TSF_ST_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif

typedef struct tsf_st_table tsf_st_table;
typedef struct tsf_st_iterator tsf_st_iterator;

struct tsf_st_hash_type {
    int (*compare)();
    int (*hash)();
};

struct tsf_st_table {
    struct tsf_st_hash_type *type;
    int num_bins;
    int num_entries;
    struct tsf_st_table_entry **bins;
};

struct tsf_st_iterator {
    tsf_st_table *table;
    int i;
    struct tsf_st_table_entry *ptr;
};

#define tsf_st_is_member(table,key) tsf_st_lookup(table,key,(char **)0)

enum tsf_st_retval {TSF_ST_CONTINUE, TSF_ST_STOP, TSF_ST_DELETE};

typedef enum tsf_st_retval (*tsf_st_func_t)(void*,void*,void*);

tsf_st_table *tsf_st_init_table(struct tsf_st_hash_type *type);
tsf_st_table *tsf_st_init_table_with_size(struct tsf_st_hash_type *type,int size);
tsf_st_table *tsf_st_init_numtable();
tsf_st_table *tsf_st_init_numtable_with_size(int size);
tsf_st_table *tsf_st_init_strtable();
tsf_st_table *tsf_st_init_strtable_with_size(int size);
int     tsf_st_delete(tsf_st_table *table,char **key,void **value),
    tsf_st_delete_safe(tsf_st_table *table,char **key,
        void **value,char *never);
int     tsf_st_insert(tsf_st_table *table,char *key,void *value),
    tsf_st_insert_noreplace(tsf_st_table *table,char *key,void *value),
    tsf_st_add_direct(tsf_st_table *table,char *key,void *value),
    tsf_st_lookup(tsf_st_table *table,char *key,void **value);
void    tsf_st_foreach(tsf_st_table *table,tsf_st_func_t func,void *arg),
    tsf_st_free_table(tsf_st_table *table),
    tsf_st_cleanup_safe(tsf_st_table *table,char *never);
tsf_st_table *tsf_st_copy(tsf_st_table *old_table);
void    tsf_st_iterator_init(tsf_st_table *table,
                             tsf_st_iterator *iter),
        tsf_st_iterator_get(tsf_st_iterator *iter,
                            char **key,
                            void **value),
        tsf_st_iterator_next(tsf_st_iterator *iter);
int     tsf_st_iterator_valid(tsf_st_iterator *iter);

#define TSF_ST_NUMCMP   ((int (*)()) 0)
#define TSF_ST_NUMHASH  ((int (*)()) -2)

#define tsf_st_numcmp   TSF_ST_NUMCMP
#define tsf_st_numhash  TSF_ST_NUMHASH

int tsf_st_strhash();

#ifdef __cplusplus
}
#endif

#endif /* TSF_ST_INCLUDED */
