/*
 * $Header: /Users/pizlo/Repository/tsf/tsf_zip_abstract.h,v 1.1.1.1 2007/05/02 23:31:06 pizlo Exp $
 *
 * tsf_zip_abstract.h -- abstraction for ZLib and libbzip2
 * by Filip Pizlo, 2004, 2005
 *
 * This abstraction does not help you for initialization and destruction, but
 * it should be quite handy for everything in between.
 */

#ifndef FP_TSF_ZIP_ABSTRACT_H
#define FP_TSF_ZIP_ABSTRACT_H

#include "tsf_types.h"

struct tsf_zip_abstract {
    uint8_t *next_in;
    uint32_t avail_in;
    
    uint8_t *next_out;
    uint32_t avail_out;
};

typedef struct tsf_zip_abstract tsf_zip_abstract_t;

enum tsf_zip_action {
    TSF_ZIP_ACT_RUN,
    TSF_ZIP_ACT_SYNC_FLUSH,
    TSF_ZIP_ACT_FULL_FLUSH,
    TSF_ZIP_ACT_FINISH
};

typedef enum tsf_zip_action tsf_zip_action_t;

enum tsf_zip_result {
    TSF_ZIP_RES_OK,
    TSF_ZIP_RES_END,
    TSF_ZIP_RES_ERROR   /* if this is returned, the error will be
                         * set. */
};

typedef enum tsf_zip_result tsf_zip_result_t;

tsf_zip_result_t tsf_zip_abstract_deflate(tsf_zip_mode_t mode,
                                          void *stream,
                                          tsf_zip_abstract_t *abstract,
                                          tsf_zip_action_t action);

tsf_zip_result_t tsf_zip_abstract_inflate(tsf_zip_mode_t mode,
                                          void *stream,
                                          tsf_zip_abstract_t *abstract,
                                          tsf_zip_action_t action);

#endif


